<!--
Project: Single Sourcing Demo.
Component: Writer (File 2 of 3).
Filename: "process_module.php".
Purpose: Checks metadata for errors and then writes out metadata to a temporary file.
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title> Single Sourcing Demo: Process Documentation Module </title>
</head>

<body>

<h1>Single Sourcing Demo</h1>
<h2>Step 2: Module Results Page</h2>

<?php

/* 
The $bufferFilename variable is used to store the name of the temporary file we will be writing to. For this exercise, this file needs to be in the same directory as this script, but it could be changed by including the directory path as part of this variable.
*/
$bufferFilename = "ss_buffer.txt";

/*
The first thing we will do is to grab the various characteristics of our software documentation from the form.
*/
$feature = $_POST["feature"];
$skillLevel = $_POST["skill_level"];
$documentation = $_POST["documentation"];

/*
In this example, rather than using another buffer file to keep track of the number of the most recently added module, we will create a module identifier by gluing together the feature being document with the skillLevel.  So, a typical module ID would look something like "introduction_beginner" or "introduction_advanced".
*/ 
$moduleId = $feature."_".$skillLevel;

/* If the feature information is missing, show an error message. */
if (empty($feature))
	{
	echo "Feature is required!<br />";
	$errors++;
	}

/* If the skill level description is missing, show an error message. */
if (empty($skillLevel))
	{
	echo "Skill level description is required!<br />";
	$errors++;
	}

/* If the documentation is missing, show an error message. */
if (empty($documentation))
	{
	echo "Documentation is required!<br />";
	$errors++;
	}

/* 
Here is the part where we check the total errors and redirect the user if need be.
*/
if ($errors > 0)
	{
	echo "There were one or more errors with your data.<br />";
	echo "Please <a href=\"javascript:history.back()\">go back</a> button and correct your input!<br />";
	}
else
	{ 

	/*
	What we are going to do now is to "glue" the variables together	into a single line using the PHP concatenation operator, 
	which is the period (.)  In order to keep each variable distinct, we will use the character sequence *** to separate each entry.
	Also, a \n (newline escape sequence) is used to make each additional entry begin on a new line.
	*/
	$gluedString = $moduleId."***".$feature."***".$skillLevel."***".$documentation."\n";

	/* 
	Now, we create a connection to the second buffer text file; the first argument is the filename and the second argument is the "mode". "a" mode means "append" and new text content		will be added to the end of the file.	$fp is a variable that holds		the "link" or connection to the file that we open and then sends this link to the fwrite function for the purpose of writing data to the file. 
	*/

	if ($fp = fopen($bufferFilename,"a"))
		{
		/* This will write the glued string to the file */
		if (fwrite($fp, $gluedString))
			{
			echo "Software documentation module added to buffer file!<br />";
			/* This closes the file after the writing is done */
			fclose($fp); 
			}
		else
			/* This is displayed if the file cannot be written to */
			{
			echo "There was an error adding your documentation.<br />";
			echo "Please check the file permissions for your buffer file.<br />";
			echo "The buffer filename is: ".$bufferFilename.".<br />";
			}
		}
	else
		{
		echo "Unable to open buffer file!";
		}

	?>

	<p>Click here to return to Step 1 and <a href="add_module.html">add another module</a>.</p>

	<p>Click here to proceed to Step 3 and <a href="finalize_modules.php">finalize all documentation modules</a> by writing them to an XML file.</p>

	<?php

	}

?>

</body>

</html>

<!-- End of "process_module.php" file -->